// ListBoxTest.cpp
// This file is public domain software.
// Copyright (C) 2019 Katayama Hirofumi MZ.
#include <windows.h>
#include <windowsx.h>

BOOL OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    return TRUE;
}

void OnPsh1(HWND hwnd)
{
    for (INT i = 0; i < 64; ++i)
    {
        TCHAR szText[64];
        wsprintf(szText, TEXT("Item %d"), i);
        SendDlgItemMessage(hwnd, lst1, LB_ADDSTRING, 0, (LPARAM)szText);
    }
}

void OnPsh2(HWND hwnd)
{
    HWND hLst1 = GetDlgItem(hwnd, lst1);

    INT iItem = (INT)SendMessage(hLst1, LB_GETCOUNT, 0, 0);
    if (iItem != LB_ERR)
    {
        SendMessage(hLst1, LB_SETSEL, FALSE, -1);
        SendMessage(hLst1, LB_SETSEL, TRUE, iItem - 1);
    }
}

void OnPsh3(HWND hwnd)
{
    SendDlgItemMessage(hwnd, lst1, LB_RESETCONTENT, 0, 0);
}

void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDOK:
    case IDCANCEL:
        EndDialog(hwnd, id);
        break;
    case psh1:
        OnPsh1(hwnd);
        break;
    case psh2:
        OnPsh2(hwnd);
        break;
    case psh3:
        OnPsh3(hwnd);
        break;
    }
}

INT_PTR CALLBACK
DialogProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hwnd, WM_INITDIALOG, OnInitDialog);
        HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    }
    return 0;
}

INT WINAPI
WinMain(HINSTANCE   hInstance,
        HINSTANCE   hPrevInstance,
        LPSTR       lpCmdLine,
        INT         nCmdShow)
{
    DialogBox(hInstance, MAKEINTRESOURCE(1), NULL, DialogProc);
    return 0;
}
